from bge import logic
from bge import types
import random


#FIXME: warn if no scene is found
def getSceneByName(name):
	for scn in logic.getSceneList():
		if scn.name == "Scene":
			return scn

def getNamedChildForLastSegment(segment, name):
	for child in segment.children:
		if (child.name == segment.name + name):
			return child


def getOtherRandomSegment():
	segment_type = random.choice(logic.all_segments)
	if logic.same_segment_loop > 5:
		print("breaking out of an endless recursion-loop?")
		return segment_type
	if segment_type.name != logic.last_segment_type.name:
		print ("other segment")
		logic.same_segment_loop = 0
		return segment_type
	else:
		print("same segment")
		logic.same_segment_loop = logic.same_segment_loop + 1
		return getOtherRandomSegment()

def addSegment(isStart):
        
	controller = logic.getCurrentController()
	own = controller.owner
	scene = logic.getCurrentScene()
	logic.same_segment_loop = 0


	str_random_number = str(random.randint(1, 99999))
	print("start")
	child_end = getNamedChildForLastSegment(logic.current_segment, "_End")
	if isStart == True:
		segment_type = random.choice(logic.all_segments)
		print("A: " + segment_type.name)
	else:
		segment_type = getOtherRandomSegment()
	print(segment_type.name)
	added_object = scene.addObject(segment_type, child_end)
	added_object.name = str_random_number + "_" + added_object.name
	for child in added_object.childrenRecursive:
		child.name = str_random_number + "_" + child.name 
	logic.last_segment = logic.current_segment
	logic.last_segment_type = segment_type
        
	logic.current_segments.append(added_object)
	logic.current_segment = added_object


def startGame():
	for scn in logic.getSceneList():
		if scn.name == "03_Hud":
			scn.end()
		if scn.name == "02_Menu" or scn.name == "04_Death":
			print("start the game now")
			mgc = logic.mgc
			mgc['in_game'] = True
			logic.addScene("01_Game")
			scn.end()          

def showGUIElement(scene, elem, show):
	if scene.name == "02_Menu":
		try:
			elem = scene.objects[elem]
			elem.setVisible(show, True)
		except:
			print ("error in finding element?")
			
def showGUIElements(scene, elem, show):
	if scene.name == "02_Menu":
		#try:
		new_state = 1
		if not show:
			new_state = 2
			
		elem = scene.objects[elem]
		print (elem.state)
		for child in elem.childrenRecursive:
			child.setVisible(show)
			child.state = new_state
		#except:
		#	print ("error in finding element?")
