import bge
import traceback
from functions import *

# variables defined here will only be set once when the
# module is first imported. Set object specific vars
# inside the function if you intend to use the module
# with multiple objects.


logic = bge.logic
keyboard = logic.keyboard

#called when a scene gets added into the game
def onStart(cont):
	own = cont.owner
	sensors = own.sensors
	scene = logic.getCurrentScene()
	
	if sensors["OnStartScene"].positive:
		if scene.name == "00_Main":
			logic.mgc = own
			logic.started_from_main = True;
			logic.addScene("02_Menu")
			own['in_game'] = False
			
		try:
			mgc = logic.mgc
		except:
			print("Error: can't start from other scenes than '00_Main'")
			logic.endGame()
			
		if scene.name == "02_Menu":
			logic.mc = own
			logic.mouse.visible = True
			showGUIElement(scene, "gold_start", True)
			showGUIElement(scene, "gold_exit", False)
			
			own['activeButton'] = 0

		if scene.name == "01_Game":
			logic.gc = own
			logic.mouse.visible = False
			if not 'hasStarted' in own:
				own['hasStarted'] = logic.mgc['isDebug']
		if scene.name == "04_Death":
			logic.mouse.visible = True


def handleInput(cont):
	own = cont.owner
	sensors = own.sensors
	scene = logic.getCurrentScene()
	
	if sensors["Update"].positive:
		JUST_ACTIVATED = logic.KX_INPUT_JUST_ACTIVATED

		if JUST_ACTIVATED in keyboard.inputs[bge.events.TKEY].queue:
			print("scene: " + scene.name)
				
		if JUST_ACTIVATED in keyboard.inputs[bge.events.MKEY].queue:
			if scene.name == "01_Game": 
				print("to menu")
				mgc = logic.mgc
				mgc['in_game'] = False
				scene.restart()
				logic.addScene("02_Menu")
						
				scene.end()
				
			if scene.name == "03_Hud":
				scene.end()
			#if scene.name == "04_Death":
			#	scene.end()

		#FIXME: add other keys to start the game
		if JUST_ACTIVATED in keyboard.inputs[bge.events.SPACEKEY].queue:
			if scene.name == "01_Game" and own['hasStarted'] == False:
				own['hasStarted'] = True
				
		

