import bge
from functions import *
import random


logic = bge.logic

def load(cont):
	scene = logic.getCurrentScene()
	own = cont.owner
	sensors = own.sensors
	
	if sensors["OnStartScene"].positive:
		if scene.name == "01_Game":
			
			for lib in logic.LibList():
				logic.LibFree(lib)

			try:
				mgc = logic.mgc
				map_file = mgc['map_file']
			except:
				print("error in loading game-file")
		

			logic.LibLoad(map_file, "Scene", scene="01_Game" )
			scene.active_camera = scene.objects['Player_Camera']
			
			logic.mgc["points"] = 0
			logic.addScene("03_Hud", 1)


def settings(cont):
	own = cont.owner
	sensors = own.sensors
	scene = logic.getCurrentScene()
	if sensors["Delay"].positive and scene.name == "01_Game":
		player = scene.objects['Player']
		player['isDebug'] = logic.mgc['isDebug']


